//+------------------------------------------------------------------+
//|                                                     CoinTest.mq4 |
//|                                                          Dubovik |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Dubovik"
#property link      ""
#property version   "1.00"
#property strict
#property script_show_inputs

#include <CCoinTest.mqh>




//--- input parameters
input int RepeatsCount=100000;
input int StartBalance = 10000;
input string S1 = "   ";
input int Deposits = 100;
input string S2 = "      ";
input int MinDeals = 10000000;
input double SuccessPercent = 50.0;
input string S3 = "  true - , SuccessPercent ";
input bool FiftyFifty = true;
input string S4 = " true -      ";
input bool FixedLot = false;




void OnStart()
{
	MathSrand(GetTickCount());

	//   PocketPercent
	int iPocketPercents[24] = {1, 2, 3, 5, 7, 10, 15, 20, 25, 30, 35, 40, 45, 50, 60, 70, 75, 80, 85, 90, 95, 97, 98, 99};
	//    
	int iTakes[15] = {5, 10, 15, 20, 50, 75, 100, 150, 200, 300, 400, 500, 1000, 2000, 3000};

	//       
	double dAvgPocket, dAvgBalance, dAvgDeals;

	CCoinTest Coin;

	Coin.SetRepeatsCount(RepeatsCount);
	Coin.SetStartBalance(StartBalance);
	Coin.SetSuccessPercent(SuccessPercent);
	Coin.SetFiftyFifty(FiftyFifty);
	Coin.SetFileName("");
	Coin.SetFixedLot(FixedLot);

	int iFile = FileOpen("Coin_Stat.csv", FILE_WRITE | FILE_CSV, "\t");
		if ( iFile != INVALID_HANDLE )
		{
			//  
			FileWrite(iFile, " ", "   ", "    ", " - ");

			int iDeposits;
				//    
				for (int i = 0; i < ArraySize(iTakes); i++)
				{
					Coin.SetTake(iTakes[i]);
						//   ,   
						for (int k = 0; k < ArraySize(iPocketPercents); k++)
						{
							Coin.SetPocketPercent(iPocketPercents[k]);

							dAvgPocket = 0;
							dAvgDeals = 0;
							dAvgBalance = 0;

							iDeposits = 0;

								// 
								for (int j = 0; (j < Deposits) || (dAvgDeals < MinDeals); j++)
								{
									Coin.Go();

									dAvgPocket += Coin.GetPocket();
									dAvgDeals += Coin.GetDeals();
									dAvgBalance += Coin.GetBalance();

									iDeposits++;
								}

							Print("Take = ", iTakes[i], ", PocketPercent = ", iPocketPercents[k]);

							dAvgPocket /= iDeposits;
							dAvgDeals /= iDeposits;
							dAvgBalance /= iDeposits;

							FileWrite(iFile, iTakes[i], iPocketPercents[k], DoubleToString(dAvgPocket + dAvgBalance, 2), DoubleToString(dAvgDeals, 2));
						}
				}
			FileClose(iFile);
		}
}
